diff -uNrd ircd-hybrid-6.0/src/s_bsd.c ircd-pi1.0a/src/s_bsd.c
--- ircd-hybrid-6.0/src/s_bsd.c	Sat Dec 30 19:12:01 2000
+++ ircd-pi1.0a/src/s_bsd.c	Thu May 23 00:22:22 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_bsd.c,v 1.129 2000/12/31 00:12:01 lusky Exp $
+ *  $Id: s_bsd.c,v 1.11 2002/05/23 04:22:22 smoli Exp $
  */
 #include "s_bsd.h"
 #include "class.h"
@@ -41,6 +41,10 @@
 #include "s_zip.h"
 #include "send.h"
 #include "struct.h"
+#include "config.h"
+#ifdef HAVE_SSL
+#include "ssl.h"
+#endif
 
 #ifdef DEBUGMODE
 #include "s_debug.h"
@@ -108,10 +112,19 @@
 void close_all_connections(void)
 {
   int i;
-  for (i = 0; i < MAXCONNECTIONS; ++i) {
-    close(i);
-    local[i] = 0;
-  }
+  struct Listener *l;
+  int is_listen;
+  
+  for(i = 0; i < MAXCONNECTIONS; ++i)
+    {
+      local[i] = NULL;
+      for(is_listen = 0, l = ListenerPollList; l; l = l->next)
+        if(l->fd == i)
+          is_listen++;
+      
+      if(!is_listen)
+        close(i);
+    }
 }
 
 void init_netio(void)
@@ -256,6 +269,32 @@
   return 1;
 }
 
+#ifdef HAVE_SSL
+int set_blocking(int fd)
+{
+#ifdef NBLOCK_SYSV
+  int res = 0;
+  if(ioctl(fd, FIONBIO, &res) == -1)
+    return 0;
+#else
+  int nonb = 0;
+  int res;
+#ifdef NBLOCK_POSIX
+  nonb |= O_NONBLOCK;
+#endif
+#ifdef NBLOCK_BSD
+  nonb |= O_NDELAY;
+#endif
+  res = fcntl(fd, F_GETFL, 0);
+  if(!(res & nonb))
+    return 0;
+  if(res == -1 || fcntl(fd, F_SETFL, res ^ nonb) == -1)
+    return 0;
+#endif
+  return 1;
+}
+#endif
+
 /*
  * deliver_it
  *      Attempt to send a sequence of bytes to the connection.
@@ -278,8 +317,13 @@
 int deliver_it(aClient* cptr, const char* str, int len)
 {
   int   retval;
-
-  retval = send(cptr->fd, str, len, 0);
+  
+  #ifdef HAVE_SSL
+  if(IsSSL(cptr))
+    retval = ssl_write(cptr, str, len);
+  else
+  #endif
+    retval = send(cptr->fd, str, len, 0);
   /*
   ** Convert WOULDBLOCK to a return of "0 bytes moved". This
   ** should occur only if socket was non-blocking. Note, that
@@ -287,28 +331,26 @@
   ** error and errno=EWOULDBLOCK.
   **
   */
-  if (retval < 0 && (errno == EWOULDBLOCK || errno == EAGAIN ||
+  if(retval < 0 && (errno == EWOULDBLOCK || errno == EAGAIN ||
                      errno == ENOBUFS))
     {
       retval = 0;
       cptr->flags |= FLAGS_BLOCKED;
       return(retval);  /* Just get out now... */
     }
-  else if (retval > 0)
-    {
-      cptr->flags &= ~FLAGS_BLOCKED;
-    }
+  else if(retval > 0)
+    cptr->flags &= ~FLAGS_BLOCKED;
 
-  if (retval > 0)
+  if(retval > 0)
     {
       cptr->sendB += retval;
       me.sendB += retval;
-      if (cptr->sendB > 1023)
+      if(cptr->sendB > 1023)
         {
           cptr->sendK += (cptr->sendB >> 10);
           cptr->sendB &= 0x03ff;        /* 2^10 = 1024, 3ff = 1023 */
         }
-      else if (me.sendB > 1023)
+      else if(me.sendB > 1023)
         {
           me.sendK += (me.sendB >> 10);
           me.sendB &= 0x03ff;
@@ -338,7 +380,7 @@
  
   ClearAccess(cptr);
 
-  if ((i = attach_Iline(cptr, username, reason)))
+  if((i = attach_Iline(cptr, username, reason)))
     {
       log(L_INFO, "Access denied: %s[%s]", cptr->name, sockname);
       return i;
@@ -354,19 +396,20 @@
  * Return         TRUE, if successfully completed
  *                FALSE, if failed and ClientExit
  */
-static int completed_connection(struct Client* cptr)
+static int completed_connection(struct Client *cptr)
 {
-  struct ConfItem* c_conf;
-  struct ConfItem* n_conf;
+  struct ConfItem *c_conf;
+  struct ConfItem *n_conf;
 
   c_conf = find_conf_name(cptr->confs, cptr->name, CONF_CONNECT_SERVER);
-  if (!c_conf)
+  if(!c_conf)
     {
       sendto_realops("Lost C-Line for %s", get_client_name(cptr,FALSE));
       return 0;
     }
+  
   n_conf = find_conf_name(cptr->confs, cptr->name, CONF_NOCONNECT_SERVER);
-  if (!n_conf)
+  if(!n_conf)
     {
       sendto_realops("Lost N-Line for %s", get_client_name(cptr,FALSE));
       return 0;
@@ -374,7 +417,37 @@
   
   SetHandshake(cptr);
 
-  if (!EmptyString(c_conf->passwd))
+#ifdef HAVE_SSL
+  if(IsSSL(cptr))
+    {
+      /* 
+       * Now initiate the SSL handshaking sequence.
+       * When it completes immediately, then continue
+       * function (sending pass, etc.)
+       * else set cptr->ssl_isconnecting
+       * Handshake will then be completed on next read event.
+       */
+       
+       sendto_realops_lev(L_DEBUG, "Initiating SSL handshake sequence for %s",
+                          cptr->name);
+      
+       if(ssl_connect(cptr))
+         {  
+           if(errno == EAGAIN)
+             {
+               sendto_realops_lev(L_DEBUG, "Pending SSL handshake for %s",
+                                  cptr->name);
+               errno = 0;
+             }
+           else
+             exit_client(cptr, cptr, &me, "SSL handshake failed.");
+           
+           return 0;
+         }              
+    }
+#endif
+  
+  if(!EmptyString(c_conf->passwd))
     sendto_one(cptr, "PASS %s :TS", c_conf->passwd);
   
   send_capabilities(cptr, (c_conf->flags & CONF_FLAGS_ZIP_LINK));
@@ -400,13 +473,13 @@
    */
   cptr->fd = socket(AF_INET, SOCK_STREAM, 0);
 
-  if (cptr->fd == -1)
+  if(cptr->fd == -1)
     {
       report_error("opening stream socket to server %s:%s", cptr->name, errno);
       return 0;
     }
 
-  if (cptr->fd >= (HARD_FDLIMIT - 10))
+  if(cptr->fd >= (HARD_FDLIMIT - 10))
     {
       sendto_realops("No more connections allowed (%s)", cptr->name);
       return 0;
@@ -427,7 +500,7 @@
    * an already bound socket, different ip# might occur anyway
    * leading to a freezing select() on this side for some time.
    */
-  if (specific_virtual_host)
+  if(specific_virtual_host)
     {
       mysk.sin_addr = vserv.sin_addr;
 
@@ -436,7 +509,7 @@
        * explicitly bind it, it will default to IN_ADDR_ANY and we lose
        * due to the other server not allowing our base IP --smg
        */        
-      if (bind(cptr->fd, (struct sockaddr*) &mysk, sizeof(mysk)))
+      if(bind(cptr->fd, (struct sockaddr*) &mysk, sizeof(mysk)))
         {
           report_error("error binding to local port for %s:%s", 
                        cptr->name, errno);
@@ -453,14 +526,14 @@
   strncpy_irc(cptr->sockhost, inetntoa((const char*) &cptr->ip.s_addr), 
               HOSTIPLEN);
 
-  if (!set_non_blocking(cptr->fd))
+  if(!set_non_blocking(cptr->fd))
     report_error(NONB_ERROR_MSG, get_client_name(cptr, TRUE), errno);
 
-  if (!set_sock_buffers(cptr->fd, READBUF_SIZE))
+  if(!set_sock_buffers(cptr->fd, READBUF_SIZE))
     report_error(SETBUF_ERROR_MSG, get_client_name(cptr, TRUE), errno);
 
-  if (connect(cptr->fd, (struct sockaddr*) &sin, sizeof(sin)) && 
-      errno != EINPROGRESS)
+  if(connect(cptr->fd, (struct sockaddr*) &sin, sizeof(sin)) && 
+     errno != EINPROGRESS)
     {
       int errtmp = errno; /* other system calls may eat errno */
       report_error("Connect to host %s failed: %s",
@@ -500,10 +573,10 @@
    * if this is coming from m_connect, we have just checked this
    * NOTE: aconf should ALWAYS be a valid C:line
    */
-  if ((cptr = find_server(aconf->name)))
+  if((cptr = find_server(aconf->name)))
     {
       sendto_realops("Server %s already present from %s",
-                 aconf->name, get_client_name(cptr, TRUE));
+                     aconf->name, get_client_name(cptr, TRUE));
       if (by && IsPerson(by) && !MyClient(by))
         sendto_one(by, ":%s NOTICE %s :Server %s already present from %s",
                    me.name, by->name, aconf->name,
@@ -536,7 +609,7 @@
     }
   }
   cptr = make_client(NULL);
-  if (reply) 
+  if(reply) 
     ++reply->ref_count;
   cptr->dns_reply = reply;
   
@@ -561,11 +634,11 @@
    * Attach config entries to client here rather than in
    * completed_connection. This to avoid null pointer references
    */
-  if (!attach_cn_lines(cptr, aconf->host))
+   if(!attach_cn_lines(cptr, aconf->host))
     {
       sendto_realops("Host %s is not enabled for connecting:no C/N-line",
                  aconf->host);
-      if (by && IsPerson(by) && !MyClient(by))
+      if(by && IsPerson(by) && !MyClient(by))
         sendto_one(by, ":%s NOTICE %s :Connect to host %s failed.",
                    me.name, by->name, cptr);
       det_confs_butmask(cptr, 0);
@@ -687,8 +760,23 @@
     cptr->dns_reply = 0;
   }
   if (-1 < cptr->fd) {
-    flush_connections(cptr);
+#ifdef HAVE_SSL
+    if(!IsSSL(cptr))
+#endif
+      flush_connections(cptr);
+    
     local[cptr->fd] = NULL;
+
+#ifdef HAVE_SSL
+    if(IsSSL(cptr) && cptr->ssl) 
+      {
+        SSL_set_shutdown(cptr->ssl, SSL_RECEIVED_SHUTDOWN);
+        ssl_shutdown(cptr->ssl);
+        SSL_free(cptr->ssl);
+        cptr->ssl = NULL;
+      }    
+#endif
+    
     fdlist_delete(cptr->fd, FDL_ALL);
     close(cptr->fd);
     cptr->fd = -1;
@@ -766,10 +854,48 @@
   new_client->listener  = listener;
   ++listener->ref_count;
 
-  if (!set_non_blocking(new_client->fd))
-    report_error(NONB_ERROR_MSG, get_client_name(new_client, TRUE), errno);
-  if (!disable_sock_options(new_client->fd))
-    report_error(OPT_ERROR_MSG, get_client_name(new_client, TRUE), errno);
+#ifdef HAVE_SSL
+  if(listener->is_ssl)
+    {
+      extern SSL_CTX *server_ctx;
+       
+      if((new_client->ssl = SSL_new(server_ctx)) == NULL)
+        {
+          sendto_realops_lev(L_DEBUG, "Creation of new SSL object for %s failed",
+                             new_client->host);
+          new_client->fd = -2;
+          free_client(new_client);
+          close(fd);
+          return;
+        }
+      
+      SetSSL(new_client);
+      set_non_blocking(fd);
+      disable_sock_options(fd);
+      SSL_set_fd(new_client->ssl, fd);
+      if(ssl_accept(new_client, fd) && errno != EAGAIN)
+        {
+          SSL_set_shutdown(new_client->ssl, SSL_RECEIVED_SHUTDOWN);
+          ssl_shutdown(new_client->ssl);
+          SSL_free(new_client->ssl);
+          new_client->fd = -2;
+          free_client(new_client);
+          close(fd);
+          return;
+        }        
+    }
+#endif
+
+#ifdef HAVE_SSL
+   if(!IsSSL(new_client))
+#endif 
+    {      
+      if(!set_non_blocking(new_client->fd))
+        report_error(NONB_ERROR_MSG, get_client_name(new_client, TRUE), errno);
+      if(!disable_sock_options(new_client->fd))
+        report_error(OPT_ERROR_MSG, get_client_name(new_client, TRUE), errno);
+    }
+  
   start_auth(new_client);
 }
 
@@ -834,7 +960,12 @@
 
   if (!(IsPerson(cptr) && DBufLength(&cptr->recvQ) > SBSD_MAX_CLIENT)) {
     errno = 0;
-    length = recv(cptr->fd, readBuf, READBUF_SIZE, 0);
+#ifdef HAVE_SSL
+    if(IsSSL(cptr))
+      length = ssl_read(cptr, readBuf, READBUF_SIZE);
+    else
+#endif
+      length = recv(cptr->fd, readBuf, READBUF_SIZE, 0);
     /*
      * If not ready, fake it so it isnt closed
      */
@@ -928,12 +1059,18 @@
                  (connected % 86400) / 3600, (connected % 3600) / 60,
                  connected % 60);
     }
+
   if (0 == error)
     strcpy(errmsg, "Remote closed the connection");
   else
     ircsprintf(errmsg, "Read error: %d (%s)", 
                current_error, strerror(current_error));
+
+  
   exit_client(cptr, cptr, &me, errmsg);
+/*  if(retry) {
+    nextconnect = try_connections(CurrentTime);
+  }*/
 }
 
 /*
@@ -964,25 +1101,29 @@
 
   now = CurrentTime;
 
-  for (res = 0;;)
+  for(res = 0;;)
     {
       FD_ZERO(read_set);
       FD_ZERO(write_set);
 
-      for (auth = AuthPollList; auth; auth = auth->next) {
-        assert(-1 < auth->fd);
-        if (IsAuthConnect(auth))
-          FD_SET(auth->fd, write_set);
-        else /* if(IsAuthPending(auth)) */
-          FD_SET(auth->fd, read_set);
-      }
-      for (listener = ListenerPollList; listener; listener = listener->next) {
-        assert(-1 < listener->fd);
-        FD_SET(listener->fd, read_set);
-      }
-      for (i = 0; i <= highest_fd; i++)
+      for(auth = AuthPollList; auth; auth = auth->next)
         {
-          if (!(GlobalFDList[i] & mask) || !(cptr = local[i]))
+          assert(-1 < auth->fd);
+          if(IsAuthConnect(auth))
+            FD_SET(auth->fd, write_set);
+          else /* if(IsAuthPending(auth)) */
+            FD_SET(auth->fd, read_set);
+        }
+      
+      for(listener = ListenerPollList; listener; listener = listener->next)
+        {
+          assert(-1 < listener->fd);
+          FD_SET(listener->fd, read_set);
+        }
+      
+      for(i = 0; i <= highest_fd; i++)
+        {
+          if(!(GlobalFDList[i] & mask) || !(cptr = local[i]))
             continue;
 
           /*
@@ -990,48 +1131,43 @@
            */
           assert(!IsMe(cptr));
 
-          if (DBufLength(&cptr->recvQ) && delay2 > 2)
+          if(DBufLength(&cptr->recvQ) && delay2 > 2)
             delay2 = 1;
-          if (DBufLength(&cptr->recvQ) < 4088)        
-            {
-               FD_SET(i, read_set);
-            }
+          
+          if(DBufLength(&cptr->recvQ) < 4088)        
+            FD_SET(i, read_set);
 
-          if (DBufLength(&cptr->sendQ) || IsConnecting(cptr)
+          if(DBufLength(&cptr->sendQ) || IsConnecting(cptr)
 #ifdef ZIP_LINKS
               || ((cptr->flags2 & FLAGS2_ZIP) && (cptr->zip->outcount > 0))
 #endif
               )
-            {
                FD_SET(i, write_set);
-            }
         }
       
-      if (ResolverFileDescriptor >= 0)
-        {
-          FD_SET(ResolverFileDescriptor, read_set);
-        }
+      if(ResolverFileDescriptor >= 0)
+        FD_SET(ResolverFileDescriptor, read_set);
+
       wait.tv_sec = IRCD_MIN(delay2, delay);
       wait.tv_usec = usec;
 
       nfds = select(MAXCONNECTIONS, read_set, write_set, 0, &wait);
 
-      if ((CurrentTime = time(NULL)) == -1)
+      if((CurrentTime = time(NULL)) == -1)
         {
           log(L_CRIT, "Clock Failure");
           restart("Clock failure");
         }   
 
-      if (nfds == -1 && errno == EINTR)
-        {
-          return -1;
-        }
-      else if( nfds >= 0)
+      if(nfds == -1 && errno == EINTR)
+        return -1;
+      else if(nfds >= 0)
         break;
 
       res++;
-      if (res > 5)
+      if(res > 5)
         restart("too many select errors");
+      
       sleep(10);
     }
 
@@ -1039,84 +1175,137 @@
    * Check the name resolver
    */
 
-  if (-1 < ResolverFileDescriptor && 
-      FD_ISSET(ResolverFileDescriptor, read_set)) {
-    get_res();
-    --nfds;
-  }
+  if(ResolverFileDescriptor > -1 &&
+     FD_ISSET(ResolverFileDescriptor, read_set))
+    {
+      get_res();
+      --nfds;
+    }
+  
   /*
    * Check the auth fd's
    */
-  for (auth = AuthPollList; auth; auth = auth_next) {
-    auth_next = auth->next;
-    assert(-1 < auth->fd);
-    if (IsAuthConnect(auth) && FD_ISSET(auth->fd, write_set)) {
-      send_auth_query(auth);
-      if (0 == --nfds)
-        break;
+  
+  for(auth = AuthPollList; auth; auth = auth_next)
+    {
+      auth_next = auth->next;
+      assert(-1 < auth->fd);
+      
+      if(IsAuthConnect(auth) && FD_ISSET(auth->fd, write_set))
+        {
+          send_auth_query(auth);
+          if(0 == --nfds)
+          break;
+        }      
+      else if(FD_ISSET(auth->fd, read_set))
+        {
+          read_auth_reply(auth);
+          if (0 == --nfds)
+            break;
+        }
     }
-    else if (FD_ISSET(auth->fd, read_set)) {
-      read_auth_reply(auth);
-      if (0 == --nfds)
-        break;
+  
+  for(listener = ListenerPollList; listener; listener = listener->next)
+    {
+      assert(-1 < listener->fd);
+      if(FD_ISSET(listener->fd, read_set))
+        accept_connection(listener);
     }
-  }
-  for (listener = ListenerPollList; listener; listener = listener->next) {
-    assert(-1 < listener->fd);
-    if (FD_ISSET(listener->fd, read_set))
-      accept_connection(listener);
-  }
 
-  for (i = 0; i <= highest_fd; i++) {
-    if (!(GlobalFDList[i] & mask) || !(cptr = local[i]))
-      continue;
+  for(i = 0; i <= highest_fd; i++)
+    {
+      if(!(GlobalFDList[i] & mask) || !(cptr = local[i]))
+        continue;
 
-    /*
-     * See if we can write...
-     */
-    if (FD_ISSET(i, write_set)) {
-      --nfds;
-      if (IsConnecting(cptr)) {
-        if (!completed_connection(cptr)) {
-          exit_client(cptr, cptr, &me, "Lost C/N Line");
+      /*
+       * See if we can write...
+       */
+#ifdef HAVE_SSL
+      if((!IsSSL(cptr) && FD_ISSET(i, write_set)) ||
+         (IsSSL(cptr) && ((cptr->write_blocked_on_read && FD_ISSET(i, read_set)) ||
+                          (!cptr->read_blocked_on_write && FD_ISSET(i, write_set)))))         
+#else      
+      if(FD_ISSET(i, write_set))
+#endif        
+        {
+          --nfds;
+          
+          if(IsConnecting(cptr))
+            {
+              if(!completed_connection(cptr))
+                {
+                  exit_client(cptr, cptr, &me, "Lost C/N Line");
+                  continue;
+                }
+#ifdef HAVE_SSL
+              if(!IsSSL(cptr)); 
+#endif
+                send_queued(cptr); /* this causes segfault in SSL_write() */
+              
+              if(!IsDead(cptr))
+                continue;
+            }
+          else
+            {
+              /* ...room for writing, empty some queue then... */
+              send_queued(cptr);
+              if(!IsDead(cptr))
+                continue;
+            }
+        
+          exit_client(cptr, cptr, &me, 
+                     (cptr->flags & FLAGS_SENDQEX) ? 
+                      "SendQ Exceeded" : strerror(get_sockerr(cptr->fd)));
           continue;
         }
-        send_queued(cptr);
-          if (!IsDead(cptr))
-            continue;
-      }
-      else {
-        /*
-         * ...room for writing, empty some queue then...
-         */
-        send_queued(cptr);
-        if (!IsDead(cptr))
-          continue;
-      }
-      exit_client(cptr, cptr, &me, 
-                 (cptr->flags & FLAGS_SENDQEX) ? 
-                 "SendQ Exceeded" : strerror(get_sockerr(cptr->fd)));
-      continue;
-    }
-    length = 1;     /* for fall through case */
+      length = 1;     /* for fall through case */
 
-    if (FD_ISSET(i, read_set)) {
-      --nfds;
-      length = read_packet(cptr);
-    }
-    else if (PARSE_AS_CLIENT(cptr) && !NoNewLine(cptr))
-      length = parse_client_queued(cptr);
+#ifdef HAVE_SSL
+      if((!IsSSL(cptr) && FD_ISSET(i, read_set)) ||
+         (IsSSL(cptr) && ((!cptr->write_blocked_on_read && FD_ISSET(i, read_set)) ||
+                          (cptr->read_blocked_on_write && FD_ISSET(i, write_set)))))
+#else        
+      if(FD_ISSET(i, read_set))
+#endif
+        {
+          --nfds;
+          
+#ifdef HAVE_SSL
+          if(cptr->ssl && IsSSL(cptr) && cptr->ssl_isconnecting)
+            {
+              sendto_realops_flags(FLAGS_DEBUG, "Doing 2nd ssl_connect attempt [select()]");
+              if(IsDead(cptr) || !ssl_connect(cptr))
+                exit_client(cptr, cptr, &me, "Handshake failed");
+              continue;
+            }
+          if(cptr->ssl && IsSSL(cptr) &&
+             !SSL_is_init_finished(cptr->ssl))
+            {
+              sendto_realops_flags(FLAGS_DEBUG, "Doing 2nd ssl_accept attempt [select()] for %p", cptr);
+              if(IsDead(cptr) || ssl_accept(cptr, cptr->fd))
+                close_connection(cptr);
+              continue;
+            }
+#endif
+          length = read_packet(cptr);
+        }
+      else if(PARSE_AS_CLIENT(cptr) && !NoNewLine(cptr))
+        length = parse_client_queued(cptr);
 
-    if (length > 0 || length == CLIENT_EXITED)
-      continue;
-    if (IsDead(cptr)) {
-       exit_client(cptr, cptr, &me,
-                    strerror(get_sockerr(cptr->fd)));
-       continue;
+      if(length > 0 || length == CLIENT_EXITED)
+        continue;
+    
+      if(IsDead(cptr))
+        {
+          exit_client(cptr, cptr, &me,
+                      strerror(get_sockerr(cptr->fd)));
+          continue;
+        }
+    
+      error_exit_client(cptr, length);
+      errno = 0;
     }
-    error_exit_client(cptr, length);
-    errno = 0;
-  }
+  
   return 0;
 }
   
@@ -1171,7 +1360,7 @@
 #define PFD_SETW(thisfd) do { CHECK_PFD(thisfd) \
                            pfd->events |= POLLWRITEFLAGS; } while (0)
 #define CHECK_PFD(thisfd)                     \
-        if (pfd->fd != thisfd) {              \
+        if(pfd->fd != thisfd) {              \
                 pfd = &poll_fdarray[nbr_pfds++];\
                 poll_fdarray[nbr_pfds].fd = -1; \
                 pfd->fd     = thisfd;           \
@@ -1200,136 +1389,167 @@
   int                  rw;
   int                  i;
 
-  for ( ; ; ) {
-    nbr_pfds = 0;
-    pfd      = poll_fdarray;
-    pfd->fd  = -1;
-    res_pfd  = NULL;
-    auth = 0;
+  for(;;)
+    {
+      nbr_pfds = 0;
+      pfd      = poll_fdarray;
+      pfd->fd  = -1;
+      res_pfd  = NULL;
+      auth = 0;
 
-    /*
-     * set resolver descriptor
-     */
-    if (ResolverFileDescriptor >= 0) {
-      PFD_SETR(ResolverFileDescriptor);
-      res_pfd = pfd;
-    }
-    /*
-     * set auth descriptors
-     */
-    for (auth = AuthPollList; auth; auth = auth->next) {
-      assert(-1 < auth->fd);
-      auth->index = nbr_pfds;
-      if (IsAuthConnect(auth))
-        PFD_SETW(auth->fd);
-      else
-        PFD_SETR(auth->fd);
-    }
-    /*
-     * set listener descriptors
-     */
-    for (listener = ListenerPollList; listener; listener = listener->next) {
-      assert(-1 < listener->fd);
+      /*
+       * set resolver descriptor
+       */
+      if(ResolverFileDescriptor >= 0)
+        {
+          PFD_SETR(ResolverFileDescriptor);
+          res_pfd = pfd;
+        }
+      
+      /*
+       * set auth descriptors
+       */      
+      for(auth = AuthPollList; auth; auth = auth->next)
+        {
+          assert(-1 < auth->fd);
+          auth->index = nbr_pfds;
+          
+          if(IsAuthConnect(auth))
+            PFD_SETW(auth->fd);
+          else
+            PFD_SETR(auth->fd);
+        }
+      
+      /*
+       * set listener descriptors
+       */
+      for(listener = ListenerPollList; listener; listener = listener->next)
+        {
+          assert(-1 < listener->fd);
 #ifdef CONNECTFAST
-      listener->index = nbr_pfds;
-      PFD_SETR(listener->fd);
+          listener->index = nbr_pfds;
+          PFD_SETR(listener->fd);
 #else
-     /* 
-      * It is VERY bad if someone tries to send a lot
-      * of clones to the server though, as mbuf's can't
-      * be allocated quickly enough... - Comstud
-      */
-      listener->index = -1;
-      if (CurrentTime > (listener->last_accept + 2)) {
-        listener->index = nbr_pfds;
-        PFD_SETR(listener->fd);
-      }
-      else if (delay2 > 2)
-        delay2 = 2;
+          /* 
+           * It is VERY bad if someone tries to send a lot
+           * of clones to the server though, as mbuf's can't
+           * be allocated quickly enough... - Comstud
+           */
+          listener->index = -1;
+          
+          if(CurrentTime > (listener->last_accept + 2))
+            {
+              listener->index = nbr_pfds;
+              PFD_SETR(listener->fd);
+            }
+          else if(delay2 > 2)
+            delay2 = 2;
 #endif
-    }
-    /*
-     * set client descriptors
-     */
-    for (i = 0; i <= highest_fd; ++i) {
-      if (!(GlobalFDList[i] & mask) || !(cptr = local[i]))
-        continue;
+        }
+      
+      /*
+       * set client descriptors
+       */
+      for(i = 0; i <= highest_fd; ++i)
+        {
+          if(!(GlobalFDList[i] & mask) || !(cptr = local[i]))
+            continue;
 
-     /*
-      * anything that IsMe should NEVER be in the local client array
-      */
-      assert(!IsMe(cptr));
-      if (DBufLength(&cptr->recvQ) && delay2 > 2)
-        delay2 = 1;
+          /*
+           * anything that IsMe should NEVER be in the local client array
+           */
+          assert(!IsMe(cptr));
+          
+          if(DBufLength(&cptr->recvQ) && delay2 > 2)
+            delay2 = 1;
 
-      if (DBufLength(&cptr->recvQ) < 4088)
-        PFD_SETR(i);
+          if(DBufLength(&cptr->recvQ) < 4088)
+            PFD_SETR(i);
       
-      if (DBufLength(&cptr->sendQ) || IsConnecting(cptr)
+          if(DBufLength(&cptr->sendQ) || IsConnecting(cptr)
 #ifdef ZIP_LINKS
-          || ((cptr->flags2 & FLAGS2_ZIP) && (cptr->zip->outcount > 0))
+             || ((cptr->flags2 & FLAGS2_ZIP) && (cptr->zip->outcount > 0))
 #endif
-          )
-        PFD_SETW(i);
-    }
+            )
+            
+          PFD_SETW(i);
+        }
 
-    wait.tv_sec = IRCD_MIN(delay2, delay);
-    wait.tv_usec = usec;
-    nfds = poll(poll_fdarray, nbr_pfds,
-                wait.tv_sec * 1000 + wait.tv_usec / 1000);
-    if ((CurrentTime = time(0)) == -1)
-      {
-        log(L_CRIT, "Clock Failure");
-        restart("Clock failed");
-      }   
-    if (nfds == -1 && ((errno == EINTR) || (errno == EAGAIN)))
-      return -1;
-    else if (nfds >= 0)
-      break;
-    report_error("poll %s:%s", me.name, errno);
-    res++;
-    if (res > 5)
-      restart("too many poll errors");
-    sleep(10);
-  }
+      wait.tv_sec = IRCD_MIN(delay2, delay);
+      wait.tv_usec = usec;
+      
+      nfds = poll(poll_fdarray, nbr_pfds,
+                  wait.tv_sec * 1000 + wait.tv_usec / 1000);
+      
+      if((CurrentTime = time(0)) == -1)
+        {
+          log(L_CRIT, "Clock Failure");
+          restart("Clock failed");
+        }
+      
+      if(nfds == -1 && ((errno == EINTR) || (errno == EAGAIN)))
+        return -1;
+      else if(nfds >= 0)
+        break;
+      
+      report_error("poll %s:%s", me.name, errno);
+      res++;
+      
+      if(res > 5)
+        restart("too many poll errors");
+      
+      sleep(10);
+    }
+  
   /*
    * check resolver descriptor
    */
-  if (res_pfd && (res_pfd->revents & (POLLREADFLAGS | POLLERRORS))) {
-    get_res();
-    --nfds;
-  }
+  if(res_pfd && (res_pfd->revents & (POLLREADFLAGS | POLLERRORS)))
+    {
+      get_res();
+      nfds--;
+    }
   /*
    * check auth descriptors
    */
-  for (auth = AuthPollList; auth; auth = auth_next) {
-    auth_next = auth->next;
-    i = auth->index;
-    /*
-     * check for any event, we only ask for one at a time
-     */
-    if (poll_fdarray[i].revents) { 
-      if (IsAuthConnect(auth))
-        send_auth_query(auth);
-      else
-        read_auth_reply(auth);
-      if (0 == --nfds)
-        break;
+  for(auth = AuthPollList; auth; auth = auth_next)
+    {
+      auth_next = auth->next;
+      i = auth->index;
+      
+      /*
+       * check for any event, we only ask for one at a time
+       */      
+      if(poll_fdarray[i].revents)
+        {
+          if(IsAuthConnect(auth))
+            send_auth_query(auth);
+          else
+            read_auth_reply(auth);
+        
+          if(0 == --nfds)
+            break;
+        }
     }
-  }
+  
   /*
    * check listeners
    */
-  for (listener = ListenerPollList; listener; listener = listener->next) {
-    if (-1 == listener->index)
-      continue;
-    i = listener->index;
-    if (poll_fdarray[i].revents) {
-      accept_connection(listener);
-      if (0 == --nfds)
-        break;
+  for(listener = ListenerPollList; listener; listener = listener->next)
+    {
+      if(-1 == listener->index)
+        continue;
+      
+      i = listener->index;
+      
+      if(poll_fdarray[i].revents)
+        {
+          accept_connection(listener);
+          if(0 == --nfds)
+            break;
+        }
     }
-  }
+  
   /*
    * i contains the next non-auth/non-listener index, since we put the 
    * resolver, auth and listener, file descriptors in poll_fdarray first, 
@@ -1337,61 +1557,104 @@
    */
   pfd = &poll_fdarray[++i];
     
-  for ( ; (i < nbr_pfds); i++, pfd++)
+  for(; (i < nbr_pfds); i++, pfd++)
     {
       fd = pfd->fd;                   
       rr = pfd->revents & POLLREADFLAGS;
       rw = pfd->revents & POLLWRITEFLAGS;
-      if (pfd->revents & POLLERRORS)
+      
+      if(pfd->revents & POLLERRORS)
         {
           if (pfd->events & POLLREADFLAGS)
             rr++;
           if (pfd->events & POLLWRITEFLAGS)
             rw++;
         }
-      if (!(cptr = local[fd]))
+      if(!(cptr = local[fd]))
         continue;
 
-      if (rw)
+#ifdef HAVE_SSL
+      if(cptr->ssl && IsSSL(cptr) && cptr->ssl_isconnecting)
         {
-          if (IsConnecting(cptr)) {
-            if (!completed_connection(cptr)) {
-              exit_client(cptr, cptr, &me, "Lost C/N Line");
-              continue;
+          sendto_realops_flags(FLAGS_DEBUG, "Doing 2nd ssl_connect attempt [poll()]");
+          if(IsDead(cptr) || !ssl_connect(cptr))
+            exit_client(cptr, cptr, &me, "Handshake failed");
+          continue;
+        }
+      if(cptr->ssl && IsSSL(cptr) &&
+         !SSL_is_init_finished(cptr->ssl))
+        {
+          sendto_realops_flags(FLAGS_DEBUG, "Doing 2nd ssl_accept attempt [poll()] for %p", cptr);
+          if(IsDead(cptr) || ssl_accept(cptr, cptr->fd))
+            close_connection(cptr);
+          continue;
+        }
+#endif
+      
+#ifdef HAVE_SSL
+      if((!IsSSL(cptr) && rw) ||
+         (IsSSL(cptr) && ((cptr->write_blocked_on_read && rr) || rw)))
+#else
+      if(rw)
+#endif
+        {
+          if(IsConnecting(cptr))
+            {
+              if(!completed_connection(cptr))
+                {
+                  exit_client(cptr, cptr, &me, "Lost C/N Line");
+                  continue;
+                }
+              
+              send_queued(cptr);
+              
+              if(!IsDead(cptr))
+                continue;
             }
-            send_queued(cptr);
-            if (!IsDead(cptr))
-              continue;
-          }
-          else {
-            /*
-             * ...room for writing, empty some queue then...
-             */
-            send_queued(cptr);
-            if (!IsDead(cptr))
-              continue;
-          }
+          else
+            {
+              /*
+               * ...room for writing, empty some queue then...
+               */
+              send_queued(cptr);
+              
+              if(!IsDead(cptr))
+                continue;
+            }
+          
           exit_client(cptr, cptr, &me, 
                      (cptr->flags & FLAGS_SENDQEX) ? 
                      "SendQ Exceeded" : strerror(get_sockerr(cptr->fd)));
-          continue;
+/*          continue;    i hope this doesn't hurt */
         }
+      
       length = 1;     /* for fall through case */
-      if (rr)
+      
+#ifdef HAVE_SSL
+      if((!IsSSL(cptr) && rr) || (IsSSL(cptr) &&
+        ((rr && !cptr->write_blocked_on_read) ||
+         (rw && cptr->read_blocked_on_write))))
+#else
+      if(rr)
+#endif        
         length = read_packet(cptr);
-      else if (PARSE_AS_CLIENT(cptr) && !NoNewLine(cptr))
+      else if(PARSE_AS_CLIENT(cptr) && !NoNewLine(cptr))
         length = parse_client_queued(cptr);
 
-      if (length > 0 || length == CLIENT_EXITED)
+      if(length > 0 || length == CLIENT_EXITED)
         continue;
-      if (IsDead(cptr)) {
-         exit_client(cptr, cptr, &me,
+      
+      if(IsDead(cptr))
+        {
+          exit_client(cptr, cptr, &me,
                       strerror(get_sockerr(cptr->fd)));
-         continue;
-      }
+          continue;
+        }
+      
       error_exit_client(cptr, length);
       errno = 0;
     }
+  
   return 0;
 }
 
